Flag = new Array(99)
ItemFlag = new Array(49);
Population = 3;

for (var i = 0; i < Flag.length; i++)
{
	Flag[i] = false;
}

for (var i = 0; i < ItemFlag.length; i++)
{
	ItemFlag[i] = false;
}

xp_chart = new Array(100)

xp_chart[0] = 10

for (var i = 1; i < xp_chart.length; i++)
{
	xp_chart[i] = Math.floor( (xp_chart[i-1] * 1.1) + (i*1.4) )
}

function SaveGame(filename)
{
	if (GetCurrentMap() != "ruin_belafon.rmp" && GetCurrentMap() != "restore_belafon.rmp")
		{
			tTextBox(80, 120, 120, "", "You may only save in Belafon!",-1);
			WaitForText();
			return;
		}

	f = OpenFile(filename)
	
	tom = false;
	kel = false;
	
	/////////////////////////////////////////////////////////////////////////////////////////	
	
	for (var i = 0; i < Flag.length; i++)
		{
			f.write("flag-"+i,Flag[i]);
		}
		
	f.write("flag-length",Flag.length);
	
	/////////////////////////////////////////////////////////////////////////////////////////	
	
	for (var i = 0; i < ItemFlag.length; i++)
		{
			f.write("iflag-"+i,ItemFlag[i]);
		}
		
	f.write("iflag-length",ItemFlag.length);
	
	/////////////////////////////////////////////////////////////////////////////////////////	
	
	for (var i = 0; i < Player.length; i++)
		{
			f.write("Player-up-"+i,Player[i].Up)
			f.write("Player-down-"+i,Player[i].Down)
			f.write("Player-left-"+i,Player[i].Left)
			f.write("Player-right-"+i,Player[i].Right)
			
			f.write("Player-A-"+i,Player[i].A)
			f.write("Player-B-"+i,Player[i].B)
			f.write("Player-C-"+i,Player[i].C)
			
			f.write("Player-NAME-"+i,Player[i].name)	
			
			n = PersonNameToNumber(Player[i].name)
			
			f.write("Player-X-"+i,GetPersonX(Player[i].name) )
			f.write("Player-Y-"+i,GetPersonY(Player[i].name) )
			f.write("Player-M-"+i, GetCurrentMap().replace(".rmp","") )
			f.write("Player-CHR-"+i, Player[i].character);
			
			if (Player[i].character == Character_Thomas) { tom = true; }
			if (Player[i].character == Character_Keli) { kel = true }		
				
			SavePerson(f,Player[i],Person[n])
		}
		
	f.write("PlayerLength",Player.length);	
		
	/////////////////////////////////////////////////////////////////////////////////////////	
	
	if (tom == false)
		{
			SavePerson(f,play_Thomas,char_Thomas)
		}
	
	if (kel == false)
		{
			SavePerson(f,play_Keli,char_Keli)
		}
		
	f.flush();		
}

function SavePerson(file,player,n)
{
			if (player.character == Character_Thomas) { c = "thomas"; }
			if (player.character == Character_Keli) { c = "keli"; }

			for (var i2 = 0; i2 < player.item.length; i2++)
				{
					f.write(c+"-item-"+i2, player.item[i2])
				}
				
			f.write(c+"-item-length",player.item.length)		
				
			for (var i2 = 0; i2 < player.weapon.length; i2++)
				{
					f.write(c+"-weapon-"+i2, player.weapon[i2])
				}
			
			f.write(c+"-weapon-length",player.weapon.length)	
				
			for (var i2 = 0; i2 < player.armor.length; i2++)
				{
					f.write(c+"-armor-"+i2, player.armor[i2])
				}	
				
			f.write(c+"-armor-length",player.armor.length)
			
			f.write(c+"-hp", n.hp)
			
			f.write(c+"-atk", n.atk)
			f.write(c+"-def", n.def)
			f.write(c+"-spd", n.spd)
					
			f.write(c+"-xp", n.xp)
			f.write(c+"-lvl", n.lvl)
			f.write(c+"-gold", n.gold);
			
			f.write(c+"-weapon_n", n.weapon)	
}

function LoadGame(filename)
{
	f = OpenFile(filename)

	/////////////////////////////////////////////////////////////////////////////////////////	
	
	l = f.read("flag-length",1);
	
	for (var i = 0; i < l; i++)
		{
			Flag[i] = f.read("flag-"+i,false);
		}
	
	/////////////////////////////////////////////////////////////////////////////////////////	
	
	l = f.read("iflag-length",1);
	
	for (var i = 0; i < l; i++)
		{
			ItemFlag[i] = f.read("iflag-"+i,false);
		}
	
	/////////////////////////////////////////////////////////////////////////////////////////	

	PlayerLength = f.read("PlayerLength",0);

	for (var i = 0; i < PlayerLength; i++)
		{
			Player[i].Up = f.read("Player-up-"+i,0)
			Player[i].Down = f.read("Player-down-"+i,0)
			Player[i].Left = f.read("Player-left-"+i,0)
			Player[i].Right = f.read("Player-right-"+i,0)
			
			Player[i].A = f.read("Player-A-"+i,0)
			Player[i].B = f.read("Player-B-"+i,0)
			Player[i].C = f.read("Player-C-"+i,0)	
			
			Player[i].name = f.read("Player-NAME-"+i,"hero")	
			
			n = PersonNameToNumber(Player[i].name)
			
			x = f.read("Player-X-"+i,0 )
			y = f.read("Player-Y-"+i,0 )
			
			Player[i].character = f.read("Player-CHR-"+i, 0);
			
			LoadPerson(f,Player[i],Person[n])
			
			if (i == 0) m = f.read("Player-M-"+i, "intro" )
		}
		
	LoadPerson(f,play_Thomas,char_Thomas)
	LoadPerson(f,play_Keli,char_Keli)
		
	Teleport( m, x, y )	
		
	/////////////////////////////////////////////////////////////////////////////////////////		
}

function GetSlotLevel(filename)
{
	f = OpenFile(filename)
	
	t = f.read("thomas-lvl",0)
	k = f.read("keli-lvl", 0)
	
	return "Thomas level "+t+", Keli level "+k
}

function LoadPerson(file,player,n)
{
			if (player.character == Character_Thomas) { c = "thomas"; }
			if (player.character == Character_Keli) { c = "keli"; player.sprite = "keli.rss"; }

			l = f.read(c+"-item-length",0)

			for (var i2 = 0; i2 < l; i2++)
				{
					player.item[i2] = f.read(c+"-item-"+i2, 0)
				}
				
			l = f.read(c+"-weapon-length",0)	
				
			for (var i2 = 0; i2 < l; i2++)
				{
					player.weapon[i2] = f.read(c+"-weapon-"+i2, 0)
				}
			
			l = f.read(c+"-armor-length",0)
				
			for (var i2 = 0; i2 < l; i2++)
				{
					player.armor[i2] = f.read(c+"-armor-"+i2, 0)
				}	
			
			n.hp = f.read(c+"-hp", 0)
			
			n.atk = f.read(c+"-atk", 0)
			n.def = f.read(c+"-def", 0)
			n.spd = f.read(c+"-spd", 0)
			
			n.xp = f.read(c+"-xp", 0)
			n.lvl = f.read(c+"-lvl", 0)
			n.gold = f.read(c+"-gold", 0)
			
			n.weapon = f.read(c+"-weapon_n", 0)			
}

function SwapCharacters()
{
	/*h = new Array(); t = new Array(); u = new Array(); ta = new Array();
	xp = new Array(); weapon = new Array(); atk = new Array(); def = new Array(); spd = new Array();
	hp = new Array(); gold = new Array(); dir = new Array(); lvl = new Array();*/
	
	i = 0
	
	if (Player[i].character == Character_Thomas)
		{
			pl = play_Thomas
			ch = char_Thomas
			pl2 = play_Keli
			ch2 = char_Keli		
			
			Player[i].character = Character_Keli
			
		}
		
	else
		{
			pl = play_Keli
			ch = char_Keli
			pl2 = play_Thomas
			ch2 = char_Thomas				
			
			Player[i].character = Character_Thomas
		}		
			
	
			p = PersonNameToNumber(Player[i].name)
			
			x = GetPersonX(Person[p].name)
			y = GetPersonY(Person[p].name)			
			
			ch.hp = Person[p].hp
			ch.xp = Person[p].xp
			ch.weapon = Person[p].weapon
			
			ch.atk = Person[p].atk
			ch.def = Person[p].def
			ch.spd = Person[p].spd
			ch.gold = Person[p].gold
			
			ch.lvl = Person[p].lvl
			
			pl.item = Player[i].item
			pl.weapon = Player[i].weapon
			
			DestroyPerson(Person[p].name)
			

			
			//////////////////////////////////////////////////////////////////////////////////////
			
			SpawnPerson("hero", pl2.sprite, x, y, ePlayerHurt, ePlayerTouch, ePlayerUpdate, ePlayerTalk)
			
			p = PersonNameToNumber(Player[i].name)
			
			Player[i].sprite = pl2.sprite
			
			Person[p].hp = ch2.hp
			Person[p].lvl = ch2.lvl
			Person[p].xp = ch2.xp
			Person[p].weapon = ch2.weapon
			
			Person[p].atk = ch2.atk
			Person[p].def = ch2.def
			Person[p].spd = ch2.spd
			
			Person[p].gold = ch2.gold
			
			Player[i].item = pl2.item
			Player[i].weapon = pl2.weapon
			
			
		
			SetPersonX(Player[i].name,x)
			SetPersonY(Player[i].name,y)			
			
			AttachCamera(Player[i].name);
			
			DestroyPerson("follow");
			
			if (Player[0].character == Character_Thomas)
				{
					sprite = "keli.rss"
				}
			else
				{
					sprite = "hero.rss"
				}
		
			CreatePerson("follow", sprite, true)	
				
			FollowPerson("follow", "hero", 16)				
			
}

//Abort(xp_chart)

/*
FLAG LIST.

0 - Cleared Out Demons
1 - cutscene crap
2 - inn keeper join
3 - item keeper join
4 - have vile mushroom
5 - talk to item keeper 1st
6 - blacksmith join
7 - talked to blacksmith
8 - Number of demons killed
9 - rouge join
10 - rouge talked to
11 - billy join
12 - billy talked to

13 - mushroom 1 [x] [m06] cFlagItem("Found Billy's mushroom #1!",13)
14 - mushroom 2 [x] [m04]
15 - mushroom 3 [x] [m11]
16 - mushroom 4 [x] [m07]
17 - mushroom 5 [x] [m14]
18 - mushroom 6 [x] [m08]
19 - mushroom 7 [x] [m09] 
20 - mushroom 8 [x] [m10] 
21 - mushroom 9 [x] [m12] 
22 - mushroom 10 [x] [m13]

23 - stan join
24 - talked to stan
25 - got gold sword

26 - ned join
27 - talked to ned

28 - keli join
29 - talked to keli
30 - keli attack

31 - damsel join

32 - town restored

33 - game beaten

*/

/*
ITEM FLAG LIST

0
1
2
3
4
5
6
7
8
9
10
11

*/

char_Thomas = new oPerson("hero",DoNothing,DoNothing,DoNothing,DoNothing)
play_Thomas = new oPlayer("hero2","hero.rss",0,0,0,0,0,0,0,0)
play_Thomas.character = 0

char_Keli = new oPerson("hero",DoNothing,DoNothing,DoNothing,DoNothing)
play_Keli = new oPlayer("hero2","keli.rss",0,0,0,0,0,0,0,0)

play_Keli.character = 1
play_Keli.sprite = "keli.rss"
char_Keli.weapon = 1;