
function IsPlayer(name)
{
	for (var i = 0; i < Player.length; i++)
		{
			if (Player[i].name == name) return true
		}
	return false
}

function PersonNameToNumber(name)
{
	for (var i = 0; i < Person.length; i++)
		{
			if (Person[i].name == name) return i
		}
		
		return -1 
}

function PersonNameToPlayerNumber(name)
{
	for (var i = 0; i < Player.length; i++)
		{
			if (Player[i].name == name) return i
		}
		
		return -1 
}

function PlayerNameToPlayerNumber(name)
{
	for (var i = 0; i < Player.length; i++)
		{
			if (Player[i].name == name) return i
		}
		
		return -1 
}

/////////////////////////////////////////////////////////////////////////////////////////

function ProcessPeople()
{
	for (var i = 0; i < Person.length; i++)
		{
			Person[i].MoveCode.Update(Person[i]);
			
			Person[i].onUpdate();
		
			/////////////////////////////////////////////////////////////////////////////////////////
			//SET NAME AND LAYER TO BE USED FOR REFERENCING THE CURRENT PERSON WE"RE ON
			/////////////////////////////////////////////////////////////////////////////////////////
		
			var name = Person[i].name
			var layer = GetPersonLayer(name)
			
			/////////////////////////////////////////////////////////////////////////////////////////
			//CHECK FOR PERSON'S OBSTRUCTIONS, IF THERE ISN'T ANY MOVE THEM BASED ON THEIR VELOCITY
			/////////////////////////////////////////////////////////////////////////////////////////
			
			
		
			if (!IsPersonObstructed(name, GetPersonX(name)+Person[i].xv, GetPersonY(name)) && //FOR X
					GetPersonX(name)+Person[i].xv < GetLayerWidth(layer)*16 && 
					GetPersonX(name)+Person[i].xv > 0)
				{
					
					SetPersonX(name, GetPersonX(name)+Person[i].xv)
				}
			else
				{
					p = GetObstructingPerson(name, GetPersonX(name)+Person[i].xv, GetPersonY(name))
					if (p != "") 
						{
							n = PersonNameToNumber(p)
							if (n != -1) Person[n].onTouch(Person[i])
						}
				}
			if (!IsPersonObstructed(name, GetPersonX(name), GetPersonY(name)+Person[i].yv) &&  // FOR Y
					GetPersonY(name)+Person[i].yv < GetLayerHeight(layer)*16 && 
					GetPersonY(name)+Person[i].yv > 0)
				{				
					SetPersonY(name, GetPersonY(name)+Person[i].yv)
				}
			else
				{
					p = GetObstructingPerson(name, GetPersonX(name), GetPersonY(name)+Person[i].yv)
					if (p != "") 
						{
							n = PersonNameToNumber(p)
							if (n != -1) Person[n].onTouch(Person[i])
						}
				}				
				
			/////////////////////////////////////////////////////////////////////////////////////////	
				
			if (IsTriggerAt(GetPersonX(name), GetPersonY(name), layer))
				{
					if (IsPlayer(name)) 
						{
							ExecuteTrigger(GetPersonX(name), GetPersonY(name), layer);
							return
						}
				}
				
			/////////////////////////////////////////////////////////////////////////////////////////
			//ANIMATE PERSON
			/////////////////////////////////////////////////////////////////////////////////////////	
			if (Person[i].xv != 0 || Person[i].yv != 0) QueuePersonCommand(name,COMMAND_ANIMATE,true)
				
			/////////////////////////////////////////////////////////////////////////////////////////
			//DECREASING PERSON'S VELOCITY/SETTING THEIR DIRECTION BASED ON IT
			/////////////////////////////////////////////////////////////////////////////////////////
				
		
			if (Person[i].yv > 0) 
				{
					//if (Person[i].yv <= 4) Person[i].yv=0; 
					Person[i].yv-=1; 
					if(Person[i].MoveCode.direction == -1) SetPersonDirection(name, "south"); 
				}
			if (Person[i].yv < 0) 
				{
					//if (Person[i].yv >= -4) Person[i].yv=0; 
					Person[i].yv+=1;
					if(Person[i].MoveCode.direction == -1) SetPersonDirection(name, "north");
				}
				
			if (Person[i].xv > 0) 
				{
					//if (Person[i].xv <= 4) Person[i].xv=0; 
					Person[i].xv-=1;
					if(Person[i].MoveCode.direction == -1) SetPersonDirection(name, "east");
				}
			if (Person[i].xv < 0) 
				{
					//if (Person[i].xv >= -4)Person[i].xv=0; 
					Person[i].xv+=1;
					if(Person[i].MoveCode.direction == -1) SetPersonDirection(name, "west"); 
				}					
			/////////////////////////////////////////////////////////////////////////////////////////
			//EXECUTING THINGS BASED ON THE PLAYER'S CURRENT STATE
			/////////////////////////////////////////////////////////////////////////////////////////
			
			switch (Person[i].state)
				{
					case State_Attack:
						Person[i].UpdateAttack();
						Person[i].state_frame++;
						
					break; case State_Recover:
						Person[i].Recover();
						Person[i].state_frame++;
					break;
				}
											
		}
		
	for (var i = 0; i < Person.length; i++)
		{
			if (Person[i].dead == true) 
				{
					for (var i2 = 0; i2 < Player.length; i2++)
						{
							n = PersonNameToNumber(Player[i2].name)
							Person[n].xp += Person[i].xp
							Person[n].gold += Person[i].gold
							LevelCheck(n)
							if (Person[i].name == Player[i2].name) 
								{
									img = LoadImage("go.png")
									img.blit(0,0)
									FadeFromColor(500, CreateColor(0,0,0) )
									t = GetTime()+2000
									while (GetTime() < t)
										 {
											 img.blit(0,0)
											 FlipScreen();
										 }
									FadeToColor(500, CreateColor(0,0,0) ) 
									Exit()
									
								}
						}
					if (Person[i].state == State_Attack) DestroyPerson(Person[i].name+"_weapon")
					n = Person[i].name
					Person.splice(i,1)
					
					DestroyPerson(n)
				}
		}		

	/////////////////////////////////////////////////////////////////////////////////////////

	for (var i = 0; i < Player.length; i++) Player[i].onUpdate();

}

/////////////////////////////////////////////////////////////////////////////////////////

var gMenuPlayer = 0;
var gInputDelay = 0

function PlayerInput()
{

	if (SuspendPlayer || Windows.length > 0) { gInputDelay = 23; return}
	
	if (gInputDelay > 0) { gInputDelay--; return  }
	
	speed = 2

	n = PersonNameToNumber(this.name)
	
	/////////////////////////////////////////////////////////////////////////////////////////

	if (IsKeyPressed(this.B)) speed = 1
	
	if (Person[n].state == State_Recover) speed = 1;

	if (IsKeyPressed(this.Down))
		{
			Person[n].yv = speed
		}
		
	if (IsKeyPressed(this.Up))
		{
			Person[n].yv = -speed
		}
		
	if (IsKeyPressed(this.Left))
		{
			Person[n].xv = -speed
		}
		
	if (IsKeyPressed(this.Right))
		{
			Person[n].xv = speed
		}
		
	/////////////////////////////////////////////////////////////////////////////////////////

	while ( AreKeysLeft() )
		{
			switch (GetKey())
				{
					case this.A:
						if (Person[n].state == State_Walk)
							{
								Person[n].StartAttack();
								ar = ['slash.wav','slash2.wav','slash3.wav']
								GetSound(ar[Random(0,2)]).play(false)
							}	
					break; case this.C:
						gMenuPlayer = PlayerNameToPlayerNumber(this.name)
						GameMenu()
					break;
				}
		}
		
}

/////////////////////////////////////////////////////////////////////////////////////////

function DoDamage(dis,other)
{
	if (dis.type == other.type) return

	hi = other.atk-(dis.def/2)
	low = other.atk-(dis.def)
	
	damage = Math.floor(Random(low,hi))
	
	if (damage < 0) damage = 0;
	
	dis.hp -= damage
	
	Particles.push( new poText(
									dis.name,
									0,-2,1,damage.toString()) );
									
	dis.invincible = true;								
									
	if (dis.hp <= 0) dis.dead = true;
}

/////////////////////////////////////////////////////////////////////////////////////////

function InvincibleUpdate(dis)
{
	if (Math.sin(GetTime()>>5) > 0)
		{
			SetPersonMask(dis.name, CreateColor(255,0,0) )
		}
	else
		{
			SetPersonMask(dis.name, CreateColor(255,255,255) )
		}

	dis.invincible_timer++;
	
	if (dis.invincible_timer >= 45)
		{
			dis.invincible = false;
			dis.invincible_timer = 0;
			
			SetPersonMask(dis.name, CreateColor(255,255,255) )
		}
}

/////////////////////////////////////////////////////////////////////////////////////////

function Teleport(map,x,y)
{

	WaitForText()
	
	RenderMap()

	h = new Array(); t = new Array(); u = new Array(); ta = new Array();
	xp = new Array(); weapon = new Array(); atk = new Array(); def = new Array(); spd = new Array();
	hp = new Array(); gold = new Array(); dir = new Array(); lvl = new Array();

	for (var i = 0; i < Player.length; i++)
		{
			p = PersonNameToNumber(Player[i].name)
			h[i] = Person[p].onHurt
			t[i] = Person[p].onTouch
			u[i] = Person[p].onUpdate
			ta[i] = Person[p].onTalk
			
			
			hp[i] = Person[p].hp
			xp[i] = Person[p].xp
			weapon[i] = Person[p].weapon
			
			atk[i] = Person[p].atk
			def[i] = Person[p].def
			spd[i] = Person[p].spd
			gold[i] = Person[p].gold
			
			lvl[i] = Person[p].lvl
			
			dir[i] = GetPersonDirection(Person[p].name)
		}
		
	p = new Array()	
		
	for (var i = 0; i < Player.length; i++)
		{
			n = PersonNameToNumber(Player[i].name)
			
			p[i] = Person[n]
		}		

	Person = new Array()
	
	FadeToColor(500, CreateColor(0,0,0) )
	
	ChangeMap(map+".rmp")
	
	for (var i = 0; i < Player.length; i++)
		{
			SpawnPerson(Player[i].name, Player[i].sprite, x, y, h[i], t[i], u[i], ta[i])
			
			
			Person[Person.length-1].hp = hp[i]
			Person[Person.length-1].lvl = lvl[i]
			Person[Person.length-1].xp = xp[i]
			Person[Person.length-1].weapon = weapon[i]
			
			Person[Person.length-1].atk = atk[i]
			Person[Person.length-1].def = def[i]
			Person[Person.length-1].spd = spd[i]
			
			Person[Person.length-1].gold = gold[i]
			
		
			SetPersonX(Player[i].name,x+(i*16))
			SetPersonY(Player[i].name,y+(i*16))
			
			SetPersonDirection(Player[i].name, dir[i]) 
			
			
			Person[Person.length-1].type = Type_Player
		}	
		
	if (Flag[28])
		{
			if (Player[0].character == Character_Thomas)
				{
					sprite = "keli.rss"
				}
			else
				{
					sprite = "hero.rss"
				}
		
			CreatePerson("follow", sprite, true)	
				
			FollowPerson("follow", "hero", 16)			
		}
		

		
	AttachCamera(Player[0].name)
	
	UpdateMapEngine()
	RenderMap()
	
	FadeFromColor(500, CreateColor(0,0,0) )
	
	

}	
	
/////////////////////////////////////////////////////////////////////////////////////////	

function LevelCheck(nu)
{
	while (Person[nu].xp >= xp_chart[Person[nu].lvl])
		{
			Person[nu].xp = Person[nu].xp-xp_chart[Person[nu].lvl];
			Person[nu].lvl++		
		
			bas = 1+Math.floor(Person[n].lvl/5)
			
			if (bas < 1) bas = 1
			
			Person[nu].atk += bas
			Person[nu].def += bas
			Person[nu].spd += bas
			
			Person[nu].hp = Person[nu].getMaxHP();
		}
}