function NPC(textbox,movecode)
{
	p = new oPerson(GetCurrentPerson(), eNPCHurt, eNPCTouch, eNPCUpdate, eNPCTalk);
	
	p.brain[0] = textbox
	
	p.talk = true
	
	p.type = Type_Player
	
	Person.push( p )
	
	PersonMove(GetCurrentPerson(), movecode)
}

function TestEnemy(movecode)
{
	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);
	
	Person.push( p )
	
	PersonMove(GetCurrentPerson(), movecode)
}

function SlimeEnemy(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("demon.rss"))

	defcode = "s1 o2 o1 o1 w6 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);
	
	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "o1 u2 w3/"
	p.brain[2] = "o1 d2 w3/"
	p.brain[3] = "o1 l2 w3/"
	p.brain[4] = "o1 r2 w3/"
	
	p.brain[5] = 100
	

	p.atk = 2
	p.def = 1
	p.spd = 1
	
	p.xp = Random(2,3)
	
	p.gold = Random(1,3)
	p.hp = 5
	p.mhp = 5
	
	p.weapon = 2;
	
	Person.push( p )
}

function ZombieEnemy(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("zdemon.rss"))

	defcode = "s1 w20 o2 w20 o1 w20 o3 w25 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);

	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "u2 w3/"
	p.brain[2] = "d2 w3/"
	p.brain[3] = "l2 w3/"
	p.brain[4] = "r2 w3/"
	
	p.brain[5] = 100

	p.atk = 3
	p.def = 3
	p.spd = 2
	
	p.xp = Random(4,6)
	
	p.gold = Random(2,4)
	p.hp = 6
	p.mhp = 6
	
	p.weapon = 2;
	
	Person.push( p )
}

function DemonBoss(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("ldemon.rss"))

	defcode = "s4 w20 o10 w20 o10 s6 w20 o10 w25 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);

	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "s4 w10 u8 /"
	p.brain[2] = "s4 w10 d8 /"
	p.brain[3] = "s4 w10 l8 /"
	p.brain[4] = "s4 w10 r8 /"
	
	p.brain[5] = 200

	p.atk = 3
	p.def = 4
	p.spd = 3
	
	p.xp = Random(20,25)
	
	p.gold = Random(50,70)
	p.hp = 6
	p.mhp = 6
	
	p.weapon = 2;
	
	Person.push( p )
}

function RedSlimeEnemy(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("rdemon.rss"))

	defcode = "s2 w25 o2 w25 o1 w25 o3 w25 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);

	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "u2 w25/"
	p.brain[2] = "d2 w25/"
	p.brain[3] = "l2 w25/"
	p.brain[4] = "r2 w25/"
	
	p.brain[5] = 60

	p.atk = 6
	p.def = 7
	p.spd = 5
	
	p.xp = Random(7,9)
	
	p.gold = Random(4,6)
	p.hp = 14
	p.mhp = 14
	
	p.weapon = 2;
	
	Person.push( p )
}

function GreenSlimeEnemy(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("demon.rss"))

	defcode = "s2 w25 o2 w25 o1 w25 o3 w25 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);

	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "u2 w25/"
	p.brain[2] = "d2 w25/"
	p.brain[3] = "l2 w25/"
	p.brain[4] = "r2 w25/"
	
	p.brain[5] = 80

	p.atk = 9
	p.def = 12
	p.spd = 8
	
	p.xp = Random(10,14)
	
	p.gold = Random(20,35)
	p.hp = 10
	p.mhp = 10
	
	p.weapon = 2;
	
	Person.push( p )
}

function DarkSlimeEnemy(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("ddemon.rss"))

	defcode = "s2 w25 o2 w25 o1 w25 o3 w25 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);

	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "u2 w15/"
	p.brain[2] = "d2 w15/"
	p.brain[3] = "l2 w15/"
	p.brain[4] = "r2 w15/"
	
	p.brain[5] = 80

	p.atk = 12
	p.def = 14
	p.spd = 8
	
	p.xp = Random(20,34)
	
	p.gold = Random(20,35)
	p.hp = 15
	p.mhp = 15
	
	p.weapon = 2;
	
	Person.push( p )
}

function BloodSlimeEnemy(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("rdemon.rss"))

	defcode = "s2 w25 o2 w25 o1 w25 o3 w25 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);

	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "u2 w5/"
	p.brain[2] = "d2 w5/"
	p.brain[3] = "l2 w5/"
	p.brain[4] = "r2 w5/"
	
	p.brain[5] = 100

	p.atk = 15
	p.def = 18
	p.spd = 14
	
	p.xp = Random(20,34)
	
	p.gold = Random(50,145)
	p.hp = 20
	p.mhp = 20
	
	p.weapon = 2;
	
	Person.push( p )
}

function LowerDemonEnemy(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("fdemon.rss"))

	defcode = "s1 o2 o1 w15 o3 w5 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);

	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "u2 o1 w1/"
	p.brain[2] = "d2 o1 w1/"
	p.brain[3] = "l2 o1 w1/"
	p.brain[4] = "r2 o1 w1/"
	
	p.brain[5] = 80

	p.atk = 12
	p.def = 10
	p.spd = 8
	
	p.xp = Random(10,15)
	
	p.gold = Random(45,60)
	p.hp = 14
	p.mhp = 14
	
	p.weapon = 2;
	
	Person.push( p )
}

function BigBossEnemy(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("ldemon.rss"))

	defcode = "s1 o2 o1 w15 o3 w5 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);

	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "u3 w1/"
	p.brain[2] = "d3 w1/"
	p.brain[3] = "l3 w1/"
	p.brain[4] = "r3 w1/"
	
	p.brain[5] = 100

	p.atk = 22
	p.def = 22
	p.spd = 21
	
	p.xp = Random(10,15)
	
	p.gold = Random(335,540)
	p.hp = 34
	p.mhp = 34
	
	p.weapon = 2;
	
	Person.push( p )
}

function KeliEnemy(movecode)
{
	SetPersonSpriteset(GetCurrentPerson(), LoadSpriteset("keli.rss"))

	defcode = "s1 o2 o1 w15 o3 w5 /"

	p = new oPerson(GetCurrentPerson(), eTestEnemyHurt, eTestEnemyTouch, eTestEnemyUpdate, eTestEnemyTalk);

	if (movecode != -1) p.brain[0] = movecode
	else { p.brain[0] = defcode } 
	p.brain[1] = "u2 w1/"
	p.brain[2] = "d2 w1/"
	p.brain[3] = "l2 w1/"
	p.brain[4] = "r2 w1/"
	
	p.brain[5] = 40

	p.atk = 12
	p.def = 10
	p.spd = 8
	
	p.xp = Random(10,15)
	
	p.gold = Random(15,20)
	p.hp = 14
	p.mhp = 14
	
	Person.push( p )
}

function FlagCheckTrue(flag)
{
	if (Flag[flag] == true) return true;
	else { DestroyPerson(GetCurrentPerson()); return false }
}

function FlagCheckFalse(flag)
{
	if (Flag[flag] == false) return true;
	else { DestroyPerson(GetCurrentPerson()); return false }
}

function cItem(item, flag)
{
	if (ItemFlag[flag] == true) { DestroyPerson( GetCurrentPerson() ); return false; }

	p = new oPerson(GetCurrentPerson(), eItemHurt, eItemTouch, eItemUpdate, eItemTalk);
	
	p.brain[1] = item
	p.brain[2] = flag
	
	p.talk = false
	
	p.type = Type_Player
	
	Person.push( p )
}

function cFlagItem(text,flag)
{
	if (Flag[flag] == true) { DestroyPerson( GetCurrentPerson() ); return false; }

	p = new oPerson(GetCurrentPerson(), eFlagSetHurt, eFlagSetTouch, eFlagSetUpdate, eFlagSetTalk);
	
	p.brain[1] = text
	p.brain[2] = flag
	
	p.talk = false
	
	p.type = Type_Player
	
	Person.push( p )
}