Bar = new Array()

BarsOn = true;

function RenderBars()
{
	if (BarsOn)
		{
			for (var i = 0; i < Bar.length; i++)
				{
					Bar[i].Render()
				}
		}
}

function UpdateBars()
{
	if (BarsOn)
		{
			for (var i = 0; i < Bar.length; i++)
				{
					Bar[i].Update()
				}
		}
}

function InitBars()
{
	Bar = new Array()

	Bar.push( new oBar( 10, 6, 10, -18, 100, 3, 0, LoadWindowStyle("hpbar.rws"), "hero") )
	Bar.push( new oBar( 15, 230, 15, 250, 50, 3, 1, LoadWindowStyle("cbar.rws"), "hero") )
	
	Bar.push( new oBar( 20, 20, -85, 20, 50, 15, 2, LoadWindowStyle("style.rws"), "hero") )
	Bar.push( new oBar( 25, 35, -85, 35, 50, 15, 3, LoadWindowStyle("style.rws"), "hero") )
	
	Bar.push( new oBar( 125, 10, 125, -50, 50, 15, 4, LoadWindowStyle("style.rws"), "hero") )
}

function oBar(x,y,x2,y2,w,h,type,style,person)
{
	this.x = x
	this.y = y
	this.x2 = x2
	this.y2 = y2
	this.cx = x2
	this.cy = y2
	
	this.w = w
	this.h = h

	this.person = person
	
	this.display_value = 0
	
	this.display = false;
	this.display_time = 0;
	
	this.style = style
	this.type = type
	
	this.speed = 1
	
	this.last_time = GetTime()
	this.time_speed = 0
	this.value_inc = 0
	
	this.Update = BarUpdate
	this.Render = BarRender
}

function BarRender()
{
	p = PersonNameToNumber(this.person)

	switch (this.type)
		{
			case 0:
				c = this.display_value
				m = Person[p].getMaxHP()
				
				this.style.drawWindow(this.cx, this.cy, this.w*(c/m), this.h)
			break; case 1:
				c = this.display_value
				m = Weapon[Person[p].weapon].recover			
				
				if (c/m == 1)
					{
						if (Math.sin(GetTime()>>6) > 0) this.style.drawWindow(this.cx, this.cy, this.w*(c/m), this.h)
					}
				else
					{
						this.style.drawWindow(this.cx, this.cy, this.w*(c/m), this.h)
					}
						
			break; case 2:
			
				this.style.drawWindow(this.cx, this.cy, Font.getStringWidth("Exp: "+this.display_value), this.h)
				Font.drawText(this.cx,this.cy,"Exp: "+this.display_value)
				//Font.drawText(this.cx,this.cy+20,"Exp: "+this.time_speed)
				
			break; case 3:
			
				this.style.drawWindow(this.cx, this.cy, Font.getStringWidth("Gold: "+this.display_value), this.h)
				Font.drawText(this.cx,this.cy,"Gold: "+this.display_value)
				//Font.drawText(this.cx,this.cy+20,"Exp: "+this.time_speed)
				
			break; case 4:
			
				this.style.drawWindow(this.cx, this.cy, Font.getStringWidth("Level "+this.display_value), this.h)
				Font.drawText(this.cx,this.cy,"Level "+this.display_value)
				//Font.drawText(this.cx,this.cy+20,"Exp: "+this.time_speed)
				
			break;		
		}

	
	
}

function BarUpdate()
{
	p = PersonNameToNumber(this.person)

	switch (this.type)
		{
			case 0:
				if (Person[p].hp != this.display_value)
					{
						if (GetTime() > this.last_time)
							{ 
								this.value_inc+=.0625
								this.last_time = GetTime()+450
							}
						if (this.value_inc > Person[p].hp-this.display_value) this.value_inc = 0;
						if (Person[p].hp > this.display_value) this.display_value+=.0625+this.value_inc;
						if (Person[p].hp < this.display_value) this.display_value-=.0625+this.value_inc;
						
						this.display = true;
						this.display_time = 200;
					}
				else
					{
						this.value_inc = 0
						this.display = false;
					}
			break; case 1:
				if (Person[p].state == State_Recover)
					{
						if (Person[p].state_frame > this.display_value) this.display_value+=1;
						if (Person[p].state_frame < this.display_value) this.display_value=Person[p].state_frame;
						
						this.display = true;
						this.display_time = 50;
					}
				else
					{			
						this.display = false;
					}			
			break; case 2:
				if (Person[p].xp != this.display_value)
					{
						if (GetTime() > this.last_time)
							{
								this.time_speed+=2;
								if (this.time_speed > 150) this.value_inc++;
								if (this.value_inc > Person[p].xp-this.display_value) this.value_inc = 0;
								if (Person[p].xp > this.display_value) this.display_value+=1+this.value_inc;
								if (Person[p].xp < this.display_value) this.display_value-=1+this.value_inc;
								this.last_time = GetTime()+150-this.time_speed
							}
						
						this.display = true;
						this.display_time = 110;
					}
				else
					{
						this.time_speed = 0
						this.value_inc = 0
						this.display = false;
					}			
			break; case 3:
				if (Person[p].gold != this.display_value)
					{
						if (GetTime() > this.last_time)
							{
								this.time_speed+=2;
								if (this.time_speed > 150) this.value_inc++;
								if (this.value_inc > Person[p].gold-this.display_value) this.value_inc = 0;
								if (Person[p].gold > this.display_value) this.display_value+=1+this.value_inc;
								if (Person[p].gold < this.display_value) this.display_value-=1+this.value_inc;
								this.last_time = GetTime()+150-this.time_speed
							}
						
						this.display = true;
						this.display_time = 100;
					}
				else
					{
						this.time_speed = 0
						this.value_inc = 0
						this.display = false;
					}			
			break; case 4:
				if (Person[p].lvl != this.display_value)
					{
						if (GetTime() > this.last_time)
							{
								this.time_speed+=2;
								if (this.time_speed > 150) this.value_inc++;
								if (this.value_inc > Person[p].lvl-this.display_value) this.value_inc = 0;
								if (Person[p].lvl > this.display_value) this.display_value+=1+this.value_inc;
								if (Person[p].lvl < this.display_value) this.display_value-=1+this.value_inc;
								this.last_time = GetTime()+150-this.time_speed
							}
						
						this.display = true;
						this.display_time = 200;
					}
				else
					{
						this.time_speed = 0
						this.value_inc = 0
						this.display = false;
					}			
			break;		
		}
		
	if (this.type == 2 || this.type == 3) this.speed = 3;	
		
	if (this.display == true || this.display_time > 0)
		{
			if (this.cx < this.x) this.cx+=this.speed;
			if (this.cx > this.x) this.cx-=this.speed;
			if (this.cy < this.y) this.cy+=this.speed;
			if (this.cy > this.y) this.cy-=this.speed;
		}
		
	if (this.display == false && this.display_time <= 0)
		{
			if (this.cx < this.x2) this.cx+=this.speed;
			if (this.cx > this.x2) this.cx-=this.speed;
			if (this.cy < this.y2) this.cy+=this.speed;
			if (this.cy > this.y2) this.cy-=this.speed;
		}		
		
	if (this.display == false && this.display_time > 0)
		{
			this.display_time--;
		}
}