/////////////////////////////////////////////////////////////////////////////////////////

TextBoxes = new Array()

/////////////////////////////////////////////////////////////////////////////////////////

function oTextBox(x,y,name,text,next)
{
	this.x = x
	this.y = y
	this.w = 180
	this.name = name
	this.text = text
	
	this.next = next
	
	this.type = 0
}

/////////////////////////////////////////////////////////////////////////////////////////

function oChoiceBox(x,y,ytext,ntext,name,text,next)
{
	this.x = x
	this.y = y
	this.w = 180
	this.name = name
	this.text = text
	this.ytext = ytext
	this.ntext = ntext
	
	this.next = next
	
	this.type = 1
}

function oFunc(func)
{
	this.func = func
	this.next = -1
	
	this.type = 2;
}

/////////////////////////////////////////////////////////////////////////////////////////

function TextBox(n)
{
	t = TextBoxes[n]

	switch (t.type)
		{
			case 0:
				tTextBox(t.x, t.y, t.w, t.name, t.text,t.next);
			break;
			
			case 1:
				tChoiceBox(t.x, t.y, t.w, t.ytext, t.ntext, t.name, t.text)
			break;
			
			case 2:
				t.func()
			break;
		}
	if (t.next != -1)
		{
			WaitForText()
			TextBox(t.next)
		}
}

/////////////////////////////////////////////////////////////////////////////////////////

function WaitForText()
{
	NextUpdate = GetTime()+UpdateRate;

	while (Windows.length > 0)
		{
			RenderMap()
			//RenderProcess_Manager_Run()
			
			if (NextUpdate < GetTime())
				{
					UpdateProcess_Manager_Run()
					UpdateMapEngine()
					
					
					NextUpdate = GetTime()+UpdateRate;
				}
			
			FlipScreen();
		}
}

function WaitForTime(t)
{
	time = 0

	NextUpdate = GetTime()+UpdateRate;

	while (time < t)
		{
			RenderMap()
			//RenderProcess_Manager_Run()
			
			if (NextUpdate < GetTime())
				{
					time++;
					UpdateProcess_Manager_Run()
					UpdateMapEngine()
					
					
					NextUpdate = GetTime()+UpdateRate;
				}
			
			FlipScreen();
		}
}

/////////////////////////////////////////////////////////////////////////////////////////

TextBoxes.push( new oTextBox( //0
											20,160,"Thomas",
											"Geez, the royal family leaves for a few hundred years and suddenly everything goes downhill...",
											-1)
							)		
							
TextBoxes.push( new oTextBox( //1
											10,170,"Thomas",
											"Hail good sir! My name is Thomas of Lezek, and your king, returned from beyond the southern seas!",
											2)
							)
							
TextBoxes.push( new oTextBox( //2
											120,160,"Pops",
											"Huh, you dont say? And look at you, got a crown on and everything.",
											3)
							)	
							
TextBoxes.push( new oTextBox( //3
											30,140,"Thomas",
											"I can assure you sir, I am indeed the rightful heir to the kingdom of Lezek, though I find that Belafon is in a sad state, indeed.",
											4)
							)		
							
TextBoxes.push( new oTextBox( //4
											100,150,"Pops",
											"Mm, well its good to see you're back, your lordship. Mom, get out here, the king has come to visit!",
											-1)
							)		
							
TextBoxes.push( new oTextBox( //5
											80,140,"Mom",
											"Well Ill be. Look at you, with a crown and everything.",
											6)
							)
							
TextBoxes.push( new oTextBox( //6
											20,140,"Thomas",
											"My name is King Thomas, madam, and frankly I feel you and your husband arent taking me seriously.",
											7)
							)	
							
TextBoxes.push( new oTextBox( //7
											110,120,"Mom",
											"Oh no, your highness. Its great youve decided to come back. Now we can finally get the castles demon infestation taken care of.",
											8)
							)	
							
TextBoxes.push( new oTextBox( //8
											20,160,"Thomas",
											"...demons?! In the castle?!",
											-1)
							)	
							
TextBoxes.push( new oTextBox( //9
											110,40,"Pops",
											"Well, more like, castle ruins, actually.",
											10)
							)	
							
TextBoxes.push( new oTextBox( //10
											20,60,"Mom",
											"Im sorry to say we dont have any rooms suitable for you lord, but if you like, I can set another place at the table for dinner, and theres a pallette in the corner if you decide to stay the night.",
											11)
							)				
							
TextBoxes.push( new oTextBox( //11
											20,160,"Thomas",
											"...thank...thank you. Both of you are very kind.",
											12)
							)
							
TextBoxes.push( new oTextBox( //12
											110,120,"Mom",
											"Well, come on Pop, I need some help in the house. Stop bothering the king so he can go about clearing out those terrible face-eating demons in his castle.",
											13)
							)			
							
TextBoxes.push( new oTextBox( //13
											20,160,"Pops",
											"Mm. Good to see you King Thomas, drop in whenever you like, sire.",
											-1)
							)																			

TextBoxes.push( new oTextBox( //14
											20,160,"Thomas",
											"This isn't the way to the castle.",
											-1)
							)		

TextBoxes.push( new oTextBox( //15
											40,60,"Thomas",
											"Aaaaaaaahh!",
											-1)
							)	
							
TextBoxes.push( new oTextBox( //16
											120,180,"Jonathon",
											"Aaaaaaaahh!",
											-1)
							)	
							
TextBoxes.push( new oTextBox( //17
											120,180,"Jonathon",
											"A demon!",
											-1)
							)	
							
TextBoxes.push( new oTextBox( //18
											40,60,"Thomas",
											"Im the king, actually.",
											19)
							)							
																																																																																																												
TextBoxes.push( new oTextBox( //19
											120,160,"Jonathon",
											"...what? You mean of Lezek? Youve been down in the cellars the whole time?",
											20)
							)						
							
TextBoxes.push( new oTextBox( //20
											40,60,"Thomas",
											"What? Oh no, dont be stupid. Just clearing out a little demon problem, you know how it is.",
											21)
							)	
							
TextBoxes.push( new oTextBox( //21
											120,180,"Jonathon",
											"Er, indeed.",
											22)
							)						
							
TextBoxes.push( new oTextBox( //22
											20,60,"Thomas",
											"So I suppose youre another one of my loyal subjects? My names Thomas by the way.",
											23)
							)		
							
TextBoxes.push( new oTextBox( //23
											40,100,"Jonathon",
											"Um, no. Im from the Kingdom of Talia in the west. My name is Jonathan, Im a traveling scholar. Ive been doing research for a book about the fall of Lezek.",
											24)
							)
							
TextBoxes.push( new oTextBox( //24
											60,35,"Thomas",
											"You mean when the Kingdoms of Talia and Malikin brutally crushed Lezek for making a pact with demons, utterly ruining the land and forcing the royal family to flee across the great southern sea and dooming the kingdom and all its people?",
											25)
							)	
							
TextBoxes.push( new oTextBox( //25
											120,180,"Jonathon",
											"...yes. Um. Sorry about that, your highness.",
											26)
							)					
							
TextBoxes.push( new oTextBox( //26
											20,60,"Thomas",
											"Oh, no hard feeling. Now, tell me Scholar Jonathan, are you a thinking man?",
											27)
							)	
							
TextBoxes.push( new oTextBox( //27
											120,120,"Jonathon",
											"Yes, your highness, I was trained in many of the thinking arts, theology, the sciences, politics...",
											28)
							)			
							
TextBoxes.push( new oTextBox( //28
											20,60,"Thomas",
											"Good, good. Now tell me, how would you like to be the Royal Advisor of the Kingdom of Lezek?",
											29)
							)		
							
TextBoxes.push( new oTextBox( //29
											120,120,"Jonathon",
											"...its certainly a tempting promotion from my current position. I would be honored to accept",
											30)
							)		
							
TextBoxes.push( new oTextBox( //30
											20,60,"Thomas",
											"Most excellent. Now, come with me Advisor Jonathan, we need to discuss the rebuilding of Belafon, and of Lezek. Let us adjourn to my royal quarters.",
											31)
							)			
							
TextBoxes.push( new oTextBox( //31
											120,180,"Jonathon",
											"Oh, the rest of your followers have set up camp nearby?",
											32)
							)							
							
TextBoxes.push( new oTextBox( //32
											20,60,"Thomas",
											"Oh no. Im actually staying at one of my loyal subjects cottages until I can find a room in the castle that has all four walls standing. Shall we be off?",
											-1)
							)						
							
TextBoxes.push( new oTextBox( //33
											120,60,"Jonathon",
											"Listen Thomas, you cant have a kingdom without subjects. Ive talked to Mom and Pop, and they tell me that there are plenty of people to be found in the countryside. You just need to convince them to move to Belafon.",
											-1)
							)				
							
TextBoxes.push( new oTextBox( //34
											40,80,"Thomas",
											"Indeed, its bloody hard rebuilding this kingdom all by myself.",
											35)
							)			
							
TextBoxes.push( new oTextBox( //35
											120,60,"Jonathon",
											"With any luck, you can hopefully find some talented individuals that will rebuild commerce, which should increase the flow of people into Belafon all by itself.",
											36)
							)		
							
TextBoxes.push( new oTextBox( //36
											40,80,"Thomas",
											"Excellent work, royal advisor. Remind me to give you a pay raise.",
											37)
							)	
							
TextBoxes.push( new oTextBox( //37
											120,180,"Jonathon",
											"Er, you dont pay me anything yet, sire.",
											38)
							)			
							
TextBoxes.push( new oTextBox( //38
											40,80,"Thomas",
											"Really? Then Ill double it after I get the taxes flowing.",
											-1)
							)										
							
TextBoxes.push( new oFunc( InnFind ) ) //39					

TextBoxes.push( new oTextBox( //40
											40,80,"Mort",
											"Hello traveler! Can I interest you in a nice bed of grass and a meal of...uh...grass, for the low, low price of 10 gold pieces?!",
											41)
							)					
							
TextBoxes.push( new oTextBox( //41
											40,140,"Thomas",
											"Can I interest you in this limited time offer to start your own inn in my fair town?",
											42)
							)	
							
TextBoxes.push( new oTextBox( //42
											20,40,"Mort",
											"That sounds like an offer I cant afford to miss!",
											-1)
							)	
							
TextBoxes.push( new oTextBox( //43
											20,40,"Mort",
											"Hey King Thomas, if youre tired of staying at the castle, why not try a night here? Our beds have been lice free since this weekend!",
											44)
							)	
							
TextBoxes.push( new oTextBox( //44
											40,80,"Thomas",
											"Can I stay for free?",
											45)
							)	
							
TextBoxes.push( new oTextBox( //45
											50,120,"Mort",
											"Hahaha, no!",
											46)
							)							
							
TextBoxes.push( new oFunc( Inn ) ) //46																																																																																																																															

TextBoxes.push( new oChoiceBox( //47
											120,140,
											"Yes","No",
											"Mort",
											"Are you staying? It's 10 gold a night.",
											-1)
							)
							
TextBoxes.push( new oTextBox( //48
											40,80,"Mort",
											"Hey! You don't have enough gold!",
											-1)
							)
							
TextBoxes.push( new oFunc( MeetBaal ) ) //49			

TextBoxes.push( new oTextBox( //50
											40,80,"Thomas",
											"Hey, you look like a traveling merchant! How would you like your very own shop?",
											51)
							)
							
TextBoxes.push( new oTextBox( //51
											40,140,"Baal",
											"IN DARKNESS WE CANNOT FIND THE LIGHT, REPENT NOW, EMBRACE THE EVIL INSIDE OF YOU.",
											52)
							)		
							
TextBoxes.push( new oTextBox( //52
											40,80,"Thomas",
											"Please stop yelling.",
											53)
							)				
							
TextBoxes.push( new oTextBox( //53
											40,140,"Baal",
											"COMMANDED AM I BY SATANIC PENTAGON TO SEEK OUT THE UNBELIEVERS.",
											54)
							)							
							
TextBoxes.push( new oTextBox( //54
											40,80,"Thomas",
											"Want to do from an indoor location while also selling general items?",
											55)
							)	
							
TextBoxes.push( new oTextBox( //55
											40,30,"Baal",
											"I SEEK IN THE DARK MISTS OF THE WILDERNESS THE MUSHROOM OF VILENESS, TO CONCOCT A POTION TO FURTHER MY EVILS.",
											56)
							)								
							
TextBoxes.push( new oTextBox( //56
											40,80,"Thomas",
											"If I get you said mushroom of vileness, will you work in my town?",
											57)
							)	
							
TextBoxes.push( new oTextBox( //57
											20,90,"Baal",
											"...YES.",
											-1)
							)		
							
TextBoxes.push( new oTextBox( //58
											40,80,"Thomas",
											"Dont mention it.",
											-1)
							)			
							
TextBoxes.push( new oTextBox( //59
											40,30,"Baal",
											"I SEEK IN THE DARK MISTS OF THE WILDERNESS THE MUSHROOM OF VILENESS, TO CONCOCT A POTION TO FURTHER MY EVILS.",
											-1)
							)		
							
TextBoxes.push( new oTextBox( //60
											20,80,"Baal",
											"THANKS BUDDY, FOR THIS, ILL TOTALLY NOT DRAIN YOUR SOUL AS YOU SLUMBER.",
											58)
							)
							
TextBoxes.push( new oTextBox( //61
											20,80,"Baal",
											"THE TIME OF DARKNESS IS FINALLY AT HAND. ALSO, THERE IS A SALE ON CANTALOUPE. STOCK UP WHILE YOU CAN, BEFORE THE HEAT DEATH CLAIMS US ALL.",
											-1)
							)	
							
TextBoxes.push( new oTextBox( //62
											40,80,"William",
											"Hello traveler, would you happen to need some new horseshoes?",
											63)
							)	
							
TextBoxes.push( new oTextBox( //63
											40,80,"Thomas",
											"Er, what? You can clearly see I have no horse. ",
											64)
							)
							
TextBoxes.push( new oTextBox( //64
											30,30,"William",
											"Well yeah, but business has been slow lately. All my customers have dried up, ever since all these damn demons started prowling around.",
											65)
							)	
							
TextBoxes.push( new oTextBox( //65
											40,80,"Thomas",
											"So youre a blacksmith by trade?",
											66)
							)						
							
TextBoxes.push( new oTextBox( //66
											30,30,"William",
											"Oh yes, but Im also a clown for childrens parties on the weekends.",
											67)
							)
							
TextBoxes.push( new oTextBox( //67
											40,80,"Thomas",
											"Oh. How terrifying. ",
											68)
							)				
							
TextBoxes.push( new oTextBox( //68
											30,30,"William",
											"You have no idea.",
											69)
							)		
							
TextBoxes.push( new oTextBox( //69
											40,80,"Thomas",
											"...so, how would you like to the official town blacksmith of Belafon? Itd have a lot more business then out here.",
											70)
							)				
							
TextBoxes.push( new oTextBox( //70
											30,25,"William",
											"Sounds like a great offer kind sir, but as you have already deduced, Im as mental as anything. So Ill take you up on your offer after you kill, oh, say a few dozen demons. Then REVENGE WILL BE MINE, AND THE CHILDREN OF THE NIGHT SHALL FEAR BLACKSMITH WILLIAM. MWAHAHAHAHAHA.",
											71)
							)	
							
TextBoxes.push( new oTextBox( //71
											40,80,"Thomas",
											"....haha? ",
											72)
							)	
							
TextBoxes.push( new oTextBox( //72
											30,30,"William",
											"MWAHAHAHAHAHA.",
											73)
							)			
							
TextBoxes.push( new oTextBox( //73
											40,80,"Thomas",
											"... ",
											74)
							)			
							
TextBoxes.push( new oTextBox( //74
											30,30,"William",
											"MWAHAHAHAHAHA!",
											75)
							)	
							
TextBoxes.push( new oTextBox( //75
											40,80,"Thomas",
											"Please stop laughing, youre scaring me. In the bowels.",
											76)
							)
							
TextBoxes.push( new oTextBox( //76
											30,30,"William",
											"Sorry.",
											-1)
							)
							
TextBoxes.push( new oTextBox( //77
											30,30,"William",
											"Ill take you up on your offer after you kill, oh, say a few dozen demons.",
											-1)
							)								
							
TextBoxes.push( new oFunc( MeetWilliam ) ) //78		

TextBoxes.push( new oTextBox( //79
											30,30,"William",
											"I find myself sneaking out at night and running around the forest dressed in my clown attire, accosting the fiends of the night with my hilarious slap-stick antics.",
											80)
							)		
							
TextBoxes.push( new oTextBox( //80
											30,80,"Thomas",
											"How do the fiends take it?",
											81)
							)	
							
TextBoxes.push( new oTextBox( //81
											60,120,"William",
											"Usually they sob in terror.",
											-1)
							)
							
TextBoxes.push( new oTextBox( //82
											60,120,"Thomas",
											"Hello fair lady. Why are you wandering alone in these woods?",
											83)
							)	
							
TextBoxes.push( new oTextBox( //83
											20,20,"Rouge",
											"Why, kind sir, I am merely resting awhile while waiting for my various retainers to return. You see, I have a considerable fortune from my late husband, and I am looking for a place to settle down quietly with it, a place where no awkward questions about my former husbands death will arise.",
											84)
							)					
							
TextBoxes.push( new oTextBox( //84
											60,30,"Thomas",
											"I know of just such a place to settle with your money, and I happen to be the King of this fair country. Come to Belafon, and I can promise you your sordid past will be behind you.",
											85)
							)				
							
TextBoxes.push( new oTextBox( //85
											20,140,"Rouge",
											"Oh Belafon? Perhaps. It was such a small little place though. If there were more people there, I would be willing to consider it...",
											-1)
							)				
							
TextBoxes.push( new oTextBox( //86
											60,120,"Rouge",
											"But I suppose it really has grown...",
											-1)
							)							
							
TextBoxes.push( new oFunc( MeetRouge ) ) //87			

TextBoxes.push( new oTextBox( //88
											60,120,"Rouge",
											"I must say, Im rather enjoying the return to city life.",
											89)
							)		
							
TextBoxes.push( new oTextBox( //89
											80,130,"Thomas",
											"Yes, Belafon is a lovely place.",
											90)
							)									
							
TextBoxes.push( new oTextBox( //90
											90,140,"Rouge",
											"Oh indeed, the complete lack of people attempting to stone me is very refreshing.",
											-1)
							)			
							
TextBoxes.push( new oTextBox( //91
											40,100,"Billy",
											"Hail and well met, king of kings!",
											92)
							)
							
TextBoxes.push( new oTextBox( //92
											90,140,"Thomas",
											"Ah, good to see someone can see me for what I am. Good eve, sir.",
											93)
							)		
							
TextBoxes.push( new oTextBox( //93
											40,100,"Billy",
											"My crotch is itching something dreadful.",
											94)
							)										
							
TextBoxes.push( new oTextBox( //94
											90,140,"Thomas",
											"...what?",
											95)
							)		
							
TextBoxes.push( new oTextBox( //95
											40,100,"Billy",
											"Dont tell anyone, but Im actually a woman.",
											96)
							)									
							
TextBoxes.push( new oTextBox( //96
											90,140,"Thomas",
											"You dont say.",
											97)
							)				
							
TextBoxes.push( new oTextBox( //97
											40,100,"Billy",
											"Today I ate a dozen mushrooms and a wandering troubadour.",
											98)
							)				
							
TextBoxes.push( new oTextBox( //98
											90,140,"Thomas",
											"Huh. Mushrooms, eh? ",
											99)
							)	
							
TextBoxes.push( new oTextBox( //99
											40,100,"Billy",
											"Id follow a man to hell and back for another ten of them, or at least giveem a quick lap dance.",
											100)
							)						
							
TextBoxes.push( new oTextBox( //100
											90,140,"Thomas",
											"Well, I suppose as a citizen of Lezek you are entitled to asking for my assistance, and we could use a local nutjob...ten mushrooms, eh?",
											-1)
							)		
							
TextBoxes.push( new oTextBox( //101
											90,140,"Billy",
											"Burhurhurhur, here comes the ass wagon! ",
											-1)
							)						
							
TextBoxes.push( new oFunc( MeetBilly ) ) //102				

TextBoxes.push( new oTextBox( //103
											90,140,"Billy",
											"Welcome to Belafon, where the women are cheap and the beer is frankly piss!",
											104)
							)			
							
TextBoxes.push( new oTextBox( //104
											130,180,"Thomas",
											"Oh Billy, you old rascal.",
											105)
							)												
							
TextBoxes.push( new oTextBox( //105
											80,100,"Billy",
											"Good sire, I dont swing that way.",
											-1)
							)		
							
TextBoxes.push( new oTextBox( //106
											80,100,"Stan",
											"Why hello there, and dont you look just darling in that coat!",
											107)
							)
							
TextBoxes.push( new oTextBox( //107
											80,100,"Thomas",
											"Er...thank you kind sir. My name is King Thomas.",
											108)
							)	
																																																																																																																																																																																																												
TextBoxes.push( new oTextBox( //108
											20,20,"Stan",
											"Well thats just fabulous! Im Stan the barbarian. ",
											109)
							)			
							
TextBoxes.push( new oTextBox( //109
											80,100,"Thomas",
											"Well met, Stan. I am looking for goodly folk to come live in my capital of the town of Belafon. ",
											110)
							)										
							
TextBoxes.push( new oTextBox( //110
											20,20,"Stan",
											"Well Tommy, that sounds just super, but it would really ruin my street cred with the other barbarians. Although, Im not against being bribed...",
											111)
							)		
							
TextBoxes.push( new oTextBox( //111
											80,100,"Thomas",
											"*sigh* With butt sex?",
											112)
							)								
							
TextBoxes.push( new oTextBox( //112
											120,100,"Stan",
											"...what? Oh, youre such a SILLY, Tommy! What makes you think Im gay?! No, what I want is a really fashionable sword. Something in gold, with lots of sparkly gems!",
											113)
							)				
							
TextBoxes.push( new oTextBox( //113
											40,100,"Thomas",
											"Oh, thank God. Sure Stan, Ill keep my eyes open for one.",
											-1)
							)							
							
TextBoxes.push( new oTextBox( //114
											80,140,"Stan",
											"Fabulous! And we can talk about getting together later. *wink*",
											-1)
							)
							
TextBoxes.push( new oTextBox( //115
											80,100,"Stan",
											"What I want is a really fashionable sword. Something in gold, with lots of sparkly gems!",
											-1)
							)																																				
							
TextBoxes.push( new oFunc( MeetStan ) ) //116		

TextBoxes.push( new oFunc( BuyGSword ) ) //117				

TextBoxes.push( new oChoiceBox( //118
											120,140,
											"Yes","No",
											"William",
											"The sword's 300 gold.",
											-1)
							)				
							
TextBoxes.push( new oTextBox( //119
											80,100,"William",
											"You don't have enough gold!",
											-1)
							)		
							
TextBoxes.push( new oTextBox( //120
											80,100,"",
											"Got gold sword!",
											-1)
							)
							
TextBoxes.push( new oTextBox( //121
											80,100,"Stan",
											"Why Tommy, hows my big man doing?",
											122)
							)
							
TextBoxes.push( new oTextBox( //122
											20,160,"Thomas",
											"Just great, Stan. Hows the barbarian business?",
											123)
							)
							
TextBoxes.push( new oTextBox( //123
											130,30,"Stan",
											"Fabulous!",
											-1)
							)	
							
TextBoxes.push( new oTextBox( //124
											30,30,"Ned",
											"Arr, who be ye?",
											125)
							)
							
TextBoxes.push( new oTextBox( //125
											130,80,"Thomas",
											"Arr, me be King Thomas, who be ye?",
											126)
							)
							
TextBoxes.push( new oTextBox( //126
											30,30,"Ned",
											"I be Pirate Ned, and I be looking for a good place to settle down and spend me ill gotten gold.",
											127)
							)																																																											
							
TextBoxes.push( new oTextBox( //127
											130,80,"Thomas",
											"Tis a good quest to be sure, what be ye skills, foul naive?",
											128)
							)			
							
TextBoxes.push( new oTextBox( //128
											30,30,"Ned",
											"Arr, Ive got an advanced masters degree in teaching. ",
											129)
							)						
							
TextBoxes.push( new oTextBox( //129
											130,80,"Thomas",
											"Good God, do you really? Then why are you a pirate?",
											130)
							)						
							
TextBoxes.push( new oTextBox( //130
											30,30,"Ned",
											"Hey, shut up. If you taught a classroom of snotnosed brats for eight hours a day, every day for ten years, youd become a pirate too.",
											131)
							)		
							
TextBoxes.push( new oTextBox( //131
											130,80,"Thomas",
											"I suppose, ever think about taking up teaching again?",
											132)
							)																						
							
TextBoxes.push( new oTextBox( //132
											30,30,"Ned",
											"Arr, for you good king Thomas, Ill consider it, if ye bring me a fair wench for a student!",
											-1)
							)
							
TextBoxes.push( new oTextBox( //133
											30,30,"Ned",
											"Arr, this Keli lass'll do fine!",
											-1)
							)	
							
TextBoxes.push( new oFunc( MeetNed ) ) //134								
							
TextBoxes.push( new oTextBox( //135
											30,30,"Keli",
											"Hail and well met, sir. My name is Keli, and I suggest you put down your sword and then throw me your gold.",
											136)
							)										
							
TextBoxes.push( new oTextBox( //136
											70,60,"Thomas",
											"My good lady, I would suggest that you not address your King in such a manner. ",
											137)
							)							
							
TextBoxes.push( new oTextBox( //137
											30,30,"Keli",
											"My crossbow suggests I can address you how I please, but since you want to do this the hard way, I suppose I could always kill you first.",
											-1)
							)			
							
TextBoxes.push( new oTextBox( //138
											70,60,"Keli",
											"Very well, I yield!",
											139)
							)	
							
TextBoxes.push( new oTextBox( //139
											20,60,"Thomas",
											"A good choice. Now, before I remove your foul head, I will give you one chance to redeem yourself. Have you ever considered a promising career as a loyal vassal to the king of Lezek?",
											140)
							)						
							
TextBoxes.push( new oTextBox( //140
											70,60,"Keli",
											"I hadnt considered it, but I admit the idea is certainly very attractive at this point.",
											141)
							)	
							
TextBoxes.push( new oTextBox( //141
											20,60,"Thomas",
											"Excellent, Ill take that as an acceptance. Now follow me, lets see about getting you a bath and some proper clothes.",
											-1)
							)
							
TextBoxes.push( new oTextBox( //142
											20,60,"Ned",
											"Arr, how be ye, Thomas?",
											143)
							)		
							
TextBoxes.push( new oTextBox( //143
											70,160,"Thomas",
											"Arr, I be...er...arr. Arrrrrrrr!",
											144)
							)		
							
TextBoxes.push( new oTextBox( //144
											20,60,"Ned",
											"...youre a weirdo, mister.",
											-1)
							)			
							
TextBoxes.push( new oTextBox( //145
											20,60,"Keli",
											"Hello my...liege. Do you require me for anything? ",
											146)
							)			
							
TextBoxes.push( new oTextBox( //146
											120,100,"Thomas",
											"I suppose a backrub is out of the question?",
											147)	
							)				
							
TextBoxes.push( new oTextBox( //147
											20,60,"Keli",
											"Only if you want it to end with a dozen crossbolts  in your back.",
											153)					
							)	
							
TextBoxes.push( new oTextBox( //148
											20,60,"Damsel Distress",
											"Ohmygod, huge thanks on the monster save, babe.",
											149)					
							)	
							
TextBoxes.push( new oTextBox( //149
											20,60,"Thomas",
											"Youre welcome, fair Damsel. Tell me, how would you like to live in a town where you can be safe from such monsters?",
											150)					
							)		
							
TextBoxes.push( new oTextBox( //150
											40,120,"Damsel Distress",
											"That sounds totally radical, kind sir. ",
											-1)					
							)	
							
TextBoxes.push( new oTextBox( //151
											20,60,"Thomas",
											"Sup, babette?",
											152)					
							)		
							
TextBoxes.push( new oTextBox( //152
											40,160,"Damsel Distress",
											"Nothing much, kingly guy.",
											-1)					
							)																																																																																																																
							
TextBoxes.push( new oFunc( KeliSwap ) ) //153										
							
TextBoxes.push( new oChoiceBox( //154
											120,140,
											"Yes","No",
											"Keli",
											"Trade places?",
											-1)
							)
							
TextBoxes.push( new oTextBox( //155
											40,160,"Pop",
											"I heard an inn keeper lives to the west, might want to keep your eye on him.",
											-1)					
							)	
							
TextBoxes.push( new oTextBox( //156
											40,160,"Mom",
											"CN forgot to do my dialogue in town, and there's like 30mins left so BEH.",
											-1)					
							)			
							
TextBoxes.push( new oChoiceBox( //157
											120,140,
											"Yes","No",
											"Jonathon",
											"It will cost 5,000 gold to upgrade the town, do you want to do so?",
											-1)
							)			
							
TextBoxes.push( new oTextBox( //158
											40,160,"Jonathon",
											"It shall be done.",
											-1)					
							)	
							
TextBoxes.push( new oTextBox( //159
											40,160,"Jonathon",
											"You don't have enough money!",
											-1)					
							)													
							
TextBoxes.push( new oFunc( JonUpgrade ) ) //160				

TextBoxes.push( new oTextBox( //161
											40,160,"Jonathon",
											"The town is looking well, Thomas",
											-1)					
							)																															
							
TextBoxes.push( new oTextBox( //162
											40,100,"Jonathon",
											"Hello Teacher Ned, hows the school doing?",
											163)					
							)	
							
TextBoxes.push( new oTextBox( //163
											40,160,"Ned",
											"Arr, tis been smooth sailing, once I reinstalled the walking the plank for missing homework.",
											164)					
							)		
							
TextBoxes.push( new oTextBox( //164
											40,100,"Jonathon",
											"...plank? But what do they fall into? ",
											165)					
							)		
							
TextBoxes.push( new oTextBox( //165
											40,160,"Ned",
											"Arr, right into yon privy. Arrharharharhar!",
											166)					
							)			
							
TextBoxes.push( new oTextBox( //166
											40,100,"Jonathon",
											"...youre a weirdo, mister.",
											-1)					
							)		
							
TextBoxes.push( new oTextBox( //167
											40,100,"",
											"Congratulations, you've gotten all the people to come to Belafon! There's not much else to do, so you've beaten the game.",
											-1)					
							)																																						
							
TextBoxes.push( new oFunc( BeatCheck ) ) //168								
							
/*TextBoxes.push( new oChoiceBox(
											120,140,
											"Yes","No",
											"Name",
											"Sexy menu!",
											-1)
							)*/			

//2,3,6

function BeatCheck()
{
	if (Flag[2] && Flag[3] && Flag[6] && Flag[9] && Flag[11] && Flag[23] && Flag[26] && Flag[28] && Flag[31] && Flag[33] == false)
		{
			TextBox(167);
			WaitForText()
			Flag[33] = true;
		}
	
}

function JonUpgrade()
{
	TextBox(157);
	
	WaitForText();
	
	if (MenuAnswer == true)
		{
			p = PersonNameToNumber(Player[0].name)
			if (Person[p].gold >= 5000) 
				{
					Person[p].gold -= 5000
					
					Flag[32] = true;	
					
					TextBox(158)		
				}	
			else
				{
					TextBox(159)
				}			
		}
}

function KeliSwap()
{
	TextBox(154);
	
	WaitForText();
	
	if (MenuAnswer == true)
		{
			SwapCharacters()
		}
}

function MeetDamsel()
{

	TextBox(148);
	
	WaitForText();
	
	Flag[31] = true;
	
	n = PersonNameToNumber("damsel");
					
	Person[n].dead = true	

}

function MeetKeli()
{
	PersonMove("hero","d1");

	TextBox(135);
	
	WaitForText()
	
	Flag[29] = true;
	Flag[30] = true;
	
	Teleport(GetCurrentMap().replace(".rmp",""),GetPersonX(Player[0].name), GetPersonY(Player[0].name))	
}

function MeetKeli2()
{
	Flag[28] = true;
	Flag[30] = false;
	
	TextBox(138);
	
	WaitForText()
}

function MeetNed()
{
	if (!Flag[27])
		{
			TextBox(124);
			Flag[27] = true;
		}
	else
		{
			if (Flag[28])
				{
					TextBox(133);
					
					WaitForText();
					
					Flag[26] = true;
					
					n = PersonNameToNumber("ned");
					
					Person[n].dead = true							
				}
			else
				{
					TextBox(132);
				}
		}
	
	
	WaitForText()
}

function BuyGSword()
{

	TextBox(118)
	
	WaitForText()

	if (MenuAnswer == true)
		{
			p = PersonNameToNumber(Player[0].name)
			if (Person[p].gold >= 300) 
				{
					Person[p].gold -= 300
					Flag[25] = true;
					
					n = PersonNameToNumber("gsword");
					
					Person[n].dead = true				
					
					TextBox(120)		
				}	
			else
				{
					TextBox(119)
				}
		}
}

function MeetStan()
{
	if (!Flag[24])
		{
			TextBox(106);
			Flag[24] = true;
		}
	else
		{
			if (Flag[25])
				{
					TextBox(114)
					Flag[23] = true
					WaitForText()
					
					n = PersonNameToNumber("stan");
					
					Person[n].dead = true							
				}
			else
				{
					TextBox(115)
				}
		}
}

function MeetBilly()
{
	if (!Flag[12])
		{
			TextBox(91);
			WaitForText()
			Flag[12] = true
		}
	else
		{
			if (Flag[13] && Flag[14] && Flag[15] && Flag[16] && Flag[17] && Flag[18] && Flag[19] && Flag[20] && Flag[21] && Flag[22])
				{
					TextBox(101)
					WaitForText()
					
					Flag[11] = true;
					
					n = PersonNameToNumber("billy");
					
					Person[n].dead = true					
				}
			else
				{
					TextBox(100);
				}
		}

		
}

function MeetRouge()
{
	if (!Flag[10])
		{
			TextBox(82);
			WaitForText();
			Flag[10] = true;
		}
	else
		{
			TextBox(85);
		}		
	if (Flag[2] && Flag[3] && Flag[6])
		{
			TextBox(86);
			WaitForText();
			Flag[9] = true
			
			n = PersonNameToNumber("rouge");
			
			Person[n].dead = true				
		}

}
							
function MeetWilliam()
{
	if (Flag[7] == false)
		{
			TextBox(62);
			WaitForText();
			Flag[7] = true;
		}
	else
		{
			if (Flag[8] < 6) TextBox(77)
			if (Flag[8] >= 6)
				{
					Flag[6] = true;
					n = PersonNameToNumber("will");
			
					Person[n].dead = true							
				}
		}
		
}							
							
function MeetBaal()
{
	if (Flag[5] == false)
		{
			TextBox(50);
			WaitForText()
			Flag[5] = true;
		}
	else
		{
			if (!Flag[4]) TextBox(59);
		}
	if (Flag[4])
		{
			TextBox(60);
			WaitForText()
			Flag[3] = true;
			n = PersonNameToNumber("baal");
	
			Person[n].dead = true			
		}
}

function Inn()
{
	TextBox(47)
	
	WaitForText();
	
	if (MenuAnswer == true) 
		{
			p = PersonNameToNumber(Player[0].name)
			if (Person[p].gold >= 10) 
				{
					Person[p].gold -= 10
				
					for (var i = 0; i < Player.length; i++)
						{
							p = PersonNameToNumber(Player[i].name)
							Person[p].hp = Person[p].getMaxHP(); 
						}
						
					//Teleport(GetCurrentMap().replace(".rmp",""),GetPersonX(Player[0].name), GetPersonY(Player[0].name))		
					
				}
			else
				{
					TextBox(48);
				}
		}
		
	
}

/////////////////////////////////////////////////////////////////////////////////////////													

function InnFind()
{
	TextBox(40);
	
	WaitForText();
	
	Flag[2] = true;
	
	n = PersonNameToNumber("mort");
	
	Person[n].dead = true
}

/////////////////////////////////////////////////////////////////////////////////////////	

function mJon2()
{
	Flag[1] = true;
	
	PersonMove("hero","s1 u5")
	PersonMove("jon","i<south> z0");
	
	WaitForMove()
	
	TextBox(33)
	
	WaitForText()
	WaitForMove()
	
	PersonMove("hero","s1 l2")
	
	WaitForText()
	WaitForMove()
	
	TextBox(34)
	
	WaitForText()
	WaitForMove()
	
	Teleport("ruin_belafon",11*16,12*16)
}
	
/////////////////////////////////////////////////////////////////////////////////////////		
	
function mJon1()
{	
								
	PersonMove("hero","s1 u2")
	PersonMove("jon","i<south> z0");
	
	TextBox(15)
	TextBox(16)				
							
	WaitForText()			
	WaitForMove()
	
	PersonMove("jon","i<south> z0 s1 u1");
	
	TextBox(17)			
	
	WaitForText()			
	WaitForMove()
	
	TextBox(18)			
	
	WaitForText()			
	WaitForMove()
	
	Teleport("belafon_jon",13*16,18*16)
	
	PersonMove("hero","w10 s1 u1");
}					

/////////////////////////////////////////////////////////////////////////////////////////					
													
function mIntro()
{

	PersonMove("pops","i<south> z0")

	PersonMove("hero","s1 r1 r3 w20 d4 w15 r7 u3 r6 u2")

	TextBox(0);

	WaitForText()
	WaitForMove()
	
	TextBox(1)
	
	WaitForText()		
	
	PersonMove("mom","x312 y231 s1 d1")
	
	WaitForMove()
	
	TextBox(5)
	
	PersonMove("hero","i<north> z0 d1 e")
	
	WaitForText();			
	WaitForMove();
	
	TextBox(9);
	
	WaitForText();
	
	PersonMove("pops","s1u1")
	PersonMove("mom","s1u1")
	
	WaitForMove()
	
	Person[0].dead = true;
	Person[1].dead = true;
	
	BarsOn = true;
	
	Teleport("01",18*16,19*16);
}													