/////////////////////////////////////////////////////////////////////////////////////////

Windows = new Array()
WindowStyle = LoadWindowStyle("style.rws")
Font = LoadFont("font.rfn")
Pointer = LoadImage("pointer.png")

MenuAnswer = -1;

TextSpeed = .6

/////////////////////////////////////////////////////////////////////////////////////////

function WindowDisplayUpdate()
{
	for (var i = 0; i < Windows.length; i++) 
		{
			if (Windows[i].dead == true) Windows.splice(i,1);
			else { Windows[i].Update(); }
			
		}
}

/////////////////////////////////////////////////////////////////////////////////////////

function WindowDisplayRender()
{
	for (var i = Windows.length-1; i > -1 ; i--) 
		{
			if (Windows[i].dead == true) Windows.splice(i,1);
			else { Windows[i].Render(); }
			
		}
}

/////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////

function oTextWindow(x, y, w, text, closeable)
{
	this.x = x
	this.y = y
	this.w = w
	this.h = -1

	this.text = text
	this.position = 0;
	this.open_position = 15;
	
	this.Render = TextRender
	this.Update = TextUpdate
	
	this.closeable = closeable
	
	this.dead = false
	this.closing = false
	
	this.close = function()
								{
									this.closing = true;
									for (var i = 0; i < this.children.length; i++)
										{
											this.children[i].close();
										}
								}
	
	this.children = new Array()
	
}

function oImageWindow(x, y, dx, dy, image)
{

	this.x = x
	this.y = y
	this.dx = dx
	this.dy = dy
	this.w = image.width
	this.h = image.height
	
	this.description = false
	
	this.open_position = 15
	
	this.image = image

	this.dead = false
	this.closing = false
	
	this.close = function()
								{
									this.closing = true;
									for (var i = 0; i < this.children.length; i++)
										{
											this.children[i].close();
										}
								}
								
	this.Render = function()
		{
			SetClippingRectangle(this.x, this.y, this.w/this.open_position, this.h/this.open_position)
			image.blit(this.x, this.y );
			SetClippingRectangle(0,0,320,240)
		}
		
	this.Update = function()
		{
			if (this.x < this.dx) this.x++;
			if (this.x > this.dx) this.x--;
			
			if (this.y < this.dy) this.y++;
			if (this.y > this.dy) this.y--;			
			
			if (this.closing == false)
				{
					if (this.open_position > 1) this.open_position-= 1
					if (this.open_position < 1) this.open_position = 1;
				}
			else
				{
					if (this.open_position < 10) this.open_position+=.5
					if (this.open_position >= 10) 
						{
							if (this.closeable) SuspendPlayer = false; 
							this.dead = true 
						}		
				}		
		}		
	
	this.children = new Array()
}

/////////////////////////////////////////////////////////////////////////////////////////

function oMenuWindow(x,y,rows,choices)
{
	this.x = x
	this.y = y
	this.w = -1
	this.h = -1
	this.rows = rows
	
	this.choices = choices
	this.position = 0;
	this.open_position = 15;
	
	this.Render = MenuRender
	this.Update = MenuUpdate
	
	this.dead = false
	this.closing = false
	
	this.close = function()
								{
									this.closing = true;
									for (var i = 0; i < this.children.length; i++)
										{
											this.children[i].close();
										}
								}
	
	this.children = new Array()
	
}

/////////////////////////////////////////////////////////////////////////////////////////

function oChoice(Title, Description, Action)
{
	this.Title = Title
	this.Description = Description
	this.Action = Action
}

/////////////////////////////////////////////////////////////////////////////////////////


function TextRender()
{
	/////////////////////////////////////////////////////////////////////////////////////////
	
	if (this.h == -1) this.h = Font.getStringHeight(this.text, this.w)
	
	/////////////////////////////////////////////////////////////////////////////////////////
		
	if (this.text.length > 0)
		{
		
			WindowStyle.drawWindow(this.x, this.y, this.w/this.open_position, this.h/this.open_position)
			
			SetClippingRectangle(this.x, this.y, this.w/this.open_position, this.h/this.open_position)
			
			Font.drawTextBox(this.x, this.y, this.w, this.h, -1, this.text.slice(0,this.position) )
			
			SetClippingRectangle(0,0,GetScreenWidth(),GetScreenHeight())
		}
	
	/////////////////////////////////////////////////////////////////////////////////////////
	
	for (var i = 0; i < this.children.length; i++) 
		{
			this.children[i].Render();
			if (this.children[i].dead == true) this.children.splice(i,1)
		}
		
	/////////////////////////////////////////////////////////////////////////////////////////	
}

/////////////////////////////////////////////////////////////////////////////////////////

function TextUpdate()
{
	
	
		
	/////////////////////////////////////////////////////////////////////////////////////////
	
	if (this.position < this.text.length) this.position+= TextSpeed;
	
	if (this.closing == false)
		{
			if (this.open_position > 1) this.open_position-= 1
			if (this.open_position < 1) this.open_position = 1;
		}
	else
		{
			if (this.open_position < 10) this.open_position+=.5
			if (this.open_position >= 10) 
				{
					SuspendPlayer = false;
					this.dead = true 
				}		
		}
	
	/////////////////////////////////////////////////////////////////////////////////////////
	
	if (this.closeable)
		{
			if (!this.closing) SuspendPlayer = true;
			if (this.open_position < 10) SuspendPlayer = true;
		
			for (var i = 0; i < Player.length; i++)
				{
					while ( AreKeysLeft() )
						{
							switch (GetKey())
								{
									case Player[i].A:
										if (this.position < this.text.length) this.position = this.text.length
										else { this.close() } 
								}
						}
				}
		}
		
	/////////////////////////////////////////////////////////////////////////////////////////

	for (var i = 0; i < this.children.length; i++) 
		{
			this.children[i].Update();
			if (this.children[i].dead == true) this.children.splice(i,1)
		}	
		
	/////////////////////////////////////////////////////////////////////////////////////////
}

/////////////////////////////////////////////////////////////////////////////////////////

function MenuRender()
{
	/////////////////////////////////////////////////////////////////////////////////////////
	
	if (this.h == -1) 
		{
			n = 0
			this.h = 0;
			
			for (var i = 0; i < this.choices.length; i++)
				{		
					n++
					if (n > this.rows) { n = 0; this.h+=Font.getHeight(); }
				}		
			if (n != 0) this.h+=Font.getHeight();
		}
	
	if (this.w == -1)
		{
			n = 0;
			w = 0;
			r = 0;
			
			for (var i = 0; i < this.choices.length; i++)
				{		
								
					n++
					
					w = w+Font.getStringWidth("  "+this.choices[i].Title)	
							
					if (w> this.w) this.w = w;
					
					if (n > this.rows) { w = 0; n = 0; r++; }		
					
				}
		}
	
	/////////////////////////////////////////////////////////////////////////////////////////
	
	WindowStyle.drawWindow(this.x, this.y, this.w/this.open_position, this.h/this.open_position)
	
	SetClippingRectangle(this.x, this.y, this.w/this.open_position, this.h/this.open_position)
	
	n = 0;
	w = 0;
	r = 0;
	
	for (var i = 0; i < this.choices.length; i++)
		{
			Font.drawText(this.x+w, this.y+(r * Font.getHeight() ), "  "+this.choices[i].Title )
			if (this.position == i) Pointer.blit(this.x+w-3, this.y+(r * Font.getHeight()))
			
			n++
			w = w+Font.getStringWidth("  "+this.choices[i].Title)
			if (n > this.rows) { w = 0; n = 0; r++; }				
		}
	
	SetClippingRectangle(0,0,GetScreenWidth(),GetScreenHeight())

	/////////////////////////////////////////////////////////////////////////////////////////

	for (var i = 0; i < this.children.length; i++) 
		{
			this.children[i].Render();
			if (this.children[i].dead == true) this.children.splice(i,1)
		}	
		
	/////////////////////////////////////////////////////////////////////////////////////////
}

/////////////////////////////////////////////////////////////////////////////////////////

function MenuUpdate()
{

		if (this.open_position < 10) SuspendPlayer = true;

	/////////////////////////////////////////////////////////////////////////////////////////

	if (this.closing == false)
		{
			if (this.open_position > 1) this.open_position-= 1
			if (this.open_position < 1) this.open_position = 1;
		}
	else
		{
			if (this.open_position < 10) this.open_position+=.5
			if (this.open_position >= 10) 
				{
					SuspendPlayer = false; 
					this.dead = true 
				}		
		}
		
	/////////////////////////////////////////////////////////////////////////////////////////
		
	for (var i = 0; i < Player.length; i++)
		{
			while ( AreKeysLeft() )
				{
					switch (GetKey())
						{
						
							case Player[i].A:
								GetSound("confirm.wav").play(false)
								this.choices[this.position].Action(this)
							break;
							
							/*case Player[i].B:
								MenuAnswer = false;
								this.close()
							break;*/
							
							case Player[i].Up:
								if (this.position-(this.rows+1) >= 0) this.position -= (this.rows+1);
							break;
							
							case Player[i].Down:
								if (this.position+(this.rows+1) < this.choices.length) this.position += (this.rows+1);
							break;
							
							case Player[i].Left:
								if (this.position-1 >= 0) this.position--;
							break;
							
							case Player[i].Right:
								if (this.position+1 < this.choices.length) this.position++;
							break;																					
							
						}
				}
		}
	
	/////////////////////////////////////////////////////////////////////////////////////////
		
	if (this.children.length > 0)
		{
			if (this.children[0].description == true)
				{
					if (this.children[0].text != this.choices[this.position].Description)
						{
							this.children[0].text = this.choices[this.position].Description
							
							this.children[0].position = 0;
							
							this.children[0].w = Font.getStringWidth(this.children[0].text)	
							
						}
						
					this.children[0].y = this.y+this.h
				}
		}

	/////////////////////////////////////////////////////////////////////////////////////////

	for (var i = 0; i < this.children.length; i++) 
		{
			this.children[i].Update();
			if (this.children[i].dead == true) this.children.splice(i,1)
		}	
		
	/////////////////////////////////////////////////////////////////////////////////////////
}

/////////////////////////////////////////////////////////////////////////////////////////

function tTextBox(x,y,w,name,text)
{

	MainBox = new oTextWindow(x,y,w,text,true) 
	MainBox.children.push( new oTextWindow(x+7,y-17,Font.getStringWidth(name),name,false) )
	
	Windows.unshift(MainBox);
}

function tChoiceBox(x,y,w,ytext,ntext,name,text)
{

	Yes = new oChoice(ytext,"","")
	No = new oChoice(ntext,"","")
	
	Yes.Action = function(parent) { MenuAnswer = true; parent.close(); }
	No.Action = function(parent) { MenuAnswer = false; parent.close(); }

	menu = new oMenuWindow(x,y,0,[Yes,No])
	
	box = new oTextWindow(x,y,w,text,false)
	
	box.Render()
	
	menu.y = (box.y+box.h)+10
	
	menu.x = box.x+5
	
	box.children.push( new oTextWindow(x+7,y-17,Font.getStringWidth(name),name,false) )
	
	menu.children.push( box )
	
	Windows.unshift(menu);
}


function tMenu(x,y,rows,choices)
{
	menu = new oMenuWindow(x,y,rows,choices)
	
	desc = new oTextWindow(x+10,y,0,"",false)
	
	desc.description = true;
	
	menu.children.push( desc )
	
	Windows.push ( menu )
}

function SaveMenu()
{
	x = 40
	y = 120


	slot1 = function (parent) { SaveGame("slot1.sav"); parent.close(); }
	slot2 = function (parent) { SaveGame("slot2.sav"); parent.close(); }
	slot3 = function (parent) { SaveGame("slot3.sav"); parent.close(); }
	close = function (parent) { parent.close(); }

	choices = [new oChoice("Cancel","",close),
						 new oChoice("Slot 1",GetSlotLevel("slot1.sav"),slot1),
						 new oChoice("Slot 2",GetSlotLevel("slot2.sav"),slot2),
						 new oChoice("Slot 3",GetSlotLevel("slot3.sav"),slot3)]
	

	menu = new oMenuWindow(x,y,0,choices)
	
	desc = new oTextWindow(x+10,y,0,"",false)
	
	desc.description = true;
	
	menu.children.push( desc )
	
	Windows.unshift ( menu )
}

function LoadMenu()
{
	x = 40
	y = 120


	slot1 = function (parent) { parent.close(); LoadGame("slot1.sav");  BarsOn = true; }
	slot2 = function (parent) { parent.close(); LoadGame("slot2.sav");  BarsOn = true; }
	slot3 = function (parent) { parent.close(); LoadGame("slot3.sav");  BarsOn = true; }
	//close = function (parent) { parent.close(); }

	choices = [new oChoice("Slot 1",GetSlotLevel("slot1.sav"),slot1),
						 new oChoice("Slot 2",GetSlotLevel("slot2.sav"),slot2),
						 new oChoice("Slot 3",GetSlotLevel("slot3.sav"),slot3)]
	

	menu = new oMenuWindow(x,y,0,choices)
	
	desc = new oTextWindow(x+10,y,0,"",false)
	
	desc.description = true;
	
	menu.children.push( desc )
	
	Windows[0].close()
	
	Windows.unshift ( menu )
}

function GameMenu()
{
	x = 10
	
	y = 110

	No = new oChoice("","","")
	No.Action = function(parent) { MenuAnswer = false; parent.close(); }

	menu = new oMenuWindow(x,y,0,[new oChoice("Close","Close menu.",No.Action),
																	 new oChoice("Items","Equip and use items.",ItemMenu),
																	 new oChoice("Weapons","Equip weapons.",DoNothing),
																	 //new oChoice("Armor","Equip armor.",DoNothing),
																	 new oChoice("Save","Save your game.",SaveMenu),
																	 new oChoice("Quit","Exit the game.",Exit)])
	
	desc = new oTextWindow(x+10,y,0,"",false)
	
	desc.description = true;
	
	menu.children.push( desc )
	
	n = PersonNameToNumber( Player[0].name );
	
	stats = new oTextWindow(x+160,y-40,140,
		"HP  - "+Person[n].hp+" / "+Person[n].getMaxHP()+"\n\n"+
		"ATK - "+Person[n].atk+"\n"+
		"DEF - "+Person[n].def+"\n"+
		"SPD - "+Person[n].spd+"\n\n"+
		"Gold - "+Person[n].gold+"\n\n"+
		"LVL - "+Person[n].lvl+"\n"+
		"EXP - "+Person[n].xp
		,false)
	
	menu.children.push(stats)
	
	Windows.push ( menu )
}

function ItemMenu()
{
	x = 20
	y = 20

	No = new oChoice("","","")
	No.Action = function(parent) { MenuAnswer = false; parent.close(); GameMenu(); }
	
	menu = new oMenuWindow(x,y,3,[])
	
	menu.choices.push( new oChoice("Close","Close menu.",No.Action) )
	
	for (var i = 0; i < Player[gMenuPlayer].item.length; i++)
		{
			menu.choices.push( new oChoice( Item[Player[gMenuPlayer].item[i]].name, Item[Player[gMenuPlayer].item[i]].description, Item[Player[gMenuPlayer].item[i]].action ) )
		}
		
	desc = new oTextWindow(x+10,y,0,"",false)
	
	desc.description = true;
	
	menu.children.push( desc )		
	
	Windows[0].close()	
		
	Windows.unshift ( menu )
}

function MainMenu(x,y,w,rows)
{

	img = new oImageWindow(0, 0,-820,-50, LoadImage("landscape.png"))
	
	img.open_position = 1;
	
	Windows.push(img);

	UpdateMapEngine()
	RenderMap()	
	
	FadeFromColor(1600, CreateColor(0,0,0) )
	
	WaitForTime(295)
	
	UpdateMapEngine()
	RenderMap()	
	
	FadeToColor(1600, CreateColor(0,0,0) )
	
	Windows = new Array()
	
	UpdateMapEngine()
	RenderMap()
	
	FadeFromColor(1600, CreateColor(0,0,0) )

	New = new oChoice("New Game","Start a new game.","")
	Load = new oChoice("Load Game","Continue an old game.","")
	Quit = new oChoice("Quit","Quit to OS.","")
	
	New.Action = function(parent) { parent.close(); Teleport("intro",0,308); PersonMove("hero","s1 r1");  }
	Load.Action = function(parent) { LoadMenu(); }
	Quit.Action = function(parent) { Exit(); parent.close(); }

	menu = new oMenuWindow(x,y,rows,[New,Load,Quit])
	
	box = new oTextWindow(x-5,y+15,w,"",false)
	box.description = true
	
	img = new oImageWindow(0, 0,0,0, LoadImage("title.png"))
	
	menu.children.push( box )
	
	menu.children.push(img)
	
	Windows.unshift(menu);
}

//tChoiceBox(60,80,140,"Yes","No","Name","Pick one!")

//Menu(20,20,2,[])

//TextBox(40,160,140,"Nameless","Hi. This is a sample text box. It's neat, isn't it? Yeah, very neat...")